import { IFactory } from "../../interfaces/IFactory";
import { CsvParserService } from "../services/CsvParserService";
import { JsonParserService } from "../services/JsonParserService";
export declare class ParserFactory implements IFactory {
    make(className: string, ...args: any[]): JsonParserService | CsvParserService | undefined;
}
